/**
*   @class Mp3View extends RemotingView
*   @author Flying
*   @copyright 2006 riafan
*/

class com.riafan.Mp3View extends com.riafan.RemotingView
{
	// tracks holder object
	private var tracks			:Object;
	private var currentTrack		:MovieClip;
	private var albumArt			:MovieClip;
	
	// tracking vars (no pun intented)
	private var currentTrackNumber		:Number;
	private var totalTracks			:Number;
	private var pausePos			:Number;
	
	// song position interval
	private var songPosInterval		:Number
	
	//////////////////////////////////////////////////////////////////////
	//
   	// 캯 (target)
	//
	//////////////////////////////////////////////////////////////////////
	
	public function Mp3View (mc:MovieClip) 
	{
		super(mc);
	}
	
	//////////////////////////////////////////////////////////////////////
	//
   	// onGetTracks listener
	//
	//////////////////////////////////////////////////////////////////////
	
	public function onGetTracks(eventObj:Object)
	{
		trace ("// onGetTracks listener")
		tracks = eventObj.data;
		
		// keep track of total tracks
		totalTracks = tracks.length;
		
		// setup the mp3 player
		iniPlayer();
	}
	
	//////////////////////////////////////////////////////////////////////
	//
   	// ò
	//
	//////////////////////////////////////////////////////////////////////
	
	public function iniPlayer ()
	{		
		// local reference
		var mv:Mp3View = this;
		
		// movieClip to hold the currently playing mp3
		target.createEmptyMovieClip ("currentTrack", 1);
		currentTrack = target.currentTrack;
		
		// movieClip to hold album art, position it
		target.createEmptyMovieClip ("albumArt", 2);
		albumArt = target.albumArt;
		albumArt._x = (Stage.width - 150) / 2;
		albumArt._y = 14;
		
		// display song position
		songPosInterval = setInterval (songPos, 50, mv);
		
		// play first song (0 represents the first object in the Tracks object not an id in the database)
		loadTrack (0);
	}
	
	//////////////////////////////////////////////////////////////////////
	//
   	// һmp3
	//
	//////////////////////////////////////////////////////////////////////
	 
	public function loadTrack (n:Number)
	{
		var currentSongTitle=tracks.getItemAt(n).title;
		trace("// loading track: " + currentSongTitle)
		
		//local reference
		var mv:Mp3View = this;
		
		// keep track :P
		currentTrackNumber = n;
		
		// sound object for the current track
		currentTrack.soundObj = undefined;
		currentTrack.soundObj = new Sound ();
		
		// what to do when the sound loads
		currentTrack.soundObj.onLoad = function () {
			currentTrack.soundObj.stop ();
			currentTrack.soundObj.start (0);
		};
		
		// what to do when the sound finished
		currentTrack.soundObj.onSoundComplete = function () {
			trace ("// complete");
			// play next track
			mv.nextTrack();
		};
		
		// load the mp3
		var currentFilename = tracks.getItemAt(n).filename;
		currentTrack.soundObj.loadSound (currentFilename, true);
		
		// load album art
		var artToLoad = tracks.getItemAt(n).album_art
		albumArt.loadMovie(artToLoad)
		
		// display artist & track name
		target.artist_txt.text = tracks.getItemAt(n).artist;
		target.title_txt.text = currentSongTitle;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//
	// ſ
	//
	/////////////////////////////////////////////////////////////////////////

	// pause
	public function pauseTrack() 
	{
		trace("// pause");
		currentTrack.soundObj.stop ();
		pausePos = currentTrack.soundObj.position / 1000;
		trace (pausePos);
	}
	
	// play
	public function playTrack() 
	{
		trace("// play");
		currentTrack.soundObj.start (pausePos);
	}
	
	// prev
	public function previousTrack() 
	{
		trace("// previous");
		pausePos = 0;
		
		// set next song to play
		if (currentTrackNumber == 0) {
			currentTrackNumber = totalTracks - 1;
		} else {
			currentTrackNumber--;
		}
		
		// play next track
		loadTrack (currentTrackNumber);
	}
	
	// next
	public function nextTrack() 
	{
		trace("// next");
		pausePos = 0;
		
		// set next song to play
		if (currentTrackNumber != totalTracks - 1) {
			currentTrackNumber++;
		} else {
			currentTrackNumber = 0;
		}
		
		// play next song
		loadTrack (currentTrackNumber);
	}
	
	
	/////////////////////////////////////////////////////////////////////////
	//
	// λ
	//
	/////////////////////////////////////////////////////////////////////////
	
	public function songPos(mv)
	{
		var time = mv.currentTrack.soundObj.position / 1000;
		var duration = mv.currentTrack.soundObj.duration / 1000;
		var elapsedTime = time / duration;
		var minutes = time / 60;
		var seconds = Math.floor (time % 60);
		if (seconds < 10) {
			var secOut = "0" + seconds;
		} else {
			var secOut = seconds;
		}
		if (minutes < 1) {
			var minOut = "00";
		} else {
			var min = Math.floor (minutes);
			if (min < 10) {
				minOut = "0" + min;
			} else {
				minOut = min;
			}
		}
		mv.target.time_txt.text = minOut + ":" + secOut;
		mv.target.elapsed._xscale = elapsedTime * 100;
	}
}