/**
*	@class RemotingModel 
*	@author Flying
*	@copyright 2006 riafan
*/
import mx.remoting.Service;
import mx.services.Log;
import mx.remoting.PendingCall;;
import mx.rpc.RelayResponder;
import mx.rpc.FaultEvent;
import mx.rpc.ResultEvent;
import mx.remoting.debug.NetDebug;
import mx.events.EventDispatcher;

class com.riafan.RemotingModel 
{
	private var gatewayURL:String;
	private var servicePath:String;
	
	private var svc:Service;
	
	public var addEventListener:Function;
	private var removeEventListener:Function;
	private var dispatchEvent:Function;
	private var dispatchQueue:Function;

	/**
   	* Constructor
	* 
	* 	@param		$gatewayURL		gateway URL
	* 	@param		$serviceName	service name
	* 	@param		$uid		username
	* 	@param		$pwd		password
	*
	*/
	public function RemotingModel($gatewayURL, $serviceName, $uid, $pwd) 
	{
		
		// initialize as a broadcaster
		EventDispatcher.initialize(this);
		
		// create a new service
		svc = new Service ($gatewayURL, null, $serviceName, null, null);
		
		// credentials
		if ($uid != undefined && $pwd != undefined) {
			svc.connection.setCredentials($uid, $pwd);
		}
		
	}
	
	/**
   	* Global fault event
	*/
	private function handleRemotingModelError(fault:FaultEvent):Void 
	{
		mx.remoting.debug.NetDebug.trace({level:"None", message:"Error: " + fault.fault.faultstring });
	}
	
	/**
   	* Event dispatcher
	* 
	* 	@param		$data		data
	* 	@param		$type		event type
	*
	*/
	private function dispatch($data, $type)
	{
		// broadcast message
  		var eventObj:Object={target:this,type:$type}
		eventObj.data = $data;
  		dispatchEvent(eventObj);
	}
	
}